// Generated by CoffeeScript 1.6.2
(function() {
  var App, Queue, Server, SqiuTaskQueue, app, http, i, log, qs, server, stq, url;

  http = require('http');

  url = require('url');

  Server = require('./server');

  SqiuTaskQueue = require('./lib/task-queue');

  Queue = require('./lib/model/Queue');

  qs = require('qs');

  log = console.log;

  server = new Server;

  stq = new SqiuTaskQueue;

  stq.start();

  stq.createQueue('seq', 'seq', 1000);

  stq.createQueue('con', 'con', 1000);

  stq.createQueue('q_push_weilv', 'seq', 1000);

  stq.createQueue('q_log_queue', 'con', 1000);

  stq.createQueue('fz_weilv_queue', 'seq', 1000);

  i = 0;

  /*
  tests
  http://127.0.0.1:1337/?action=add_task&qname=sdfdsf&url=http://127.0.0.1:1337/?hahah=1
  */


  App = (function() {
    function App() {
      console.log('App init');
    }

    App.prototype.actions = {
      create_queue: function(req, res) {
        stq.createQueue(req.qp('qname'), req.qp('type'), 1000 + i++);
        return res.dieWithJSON(0, 'success');
      },
      remove_queue: function(req, res) {
        return res.dieWithJSON(0, 'remove_queue');
      },
      update_queue: function(req, res) {
        return res.dieWithJSON(0, 'update_queue');
      },
      get_queue: function(req, res) {
        return res.dieWithJSON(0, 'get_queue');
      },
      get_queues: function(req, res) {
        var queues;

        queues = stq.getQueues();
        return res.dieWithJSON(0, queues);
      },
      add_task: function(req, res) {
        stq.addTask(req.qp('qname'), {
          url: req.qp('url'),
          postdata: req.qp('postdata'),
          prior: req.qp('prior'),
          options: req.qp('options')
        });
        return res.dieWithJSON(0, 'success');
      },
      get_tasks: function(req, res) {
        var tasks;

        tasks = stq.getTasks(req.qp('qname'));
        return res.dieWithJSON(0, tasks);
      },
      clear_tasks: function(req, res) {
        return res.dieWithJSON(0, 'clear_tasks');
      }
    };

    App.prototype.attachUtil = function(req, res) {
      var buffer, query, urlinfo;

      buffer = '';
      urlinfo = url.parse(req.url, true);
      query = urlinfo.query;
      res.json = function(o) {
        return JSON.stringify(o);
      };
      res.dieWithJSON = function(code, msg) {
        if (msg == null) {
          msg = '';
        }
        res.clear();
        return res.finish(res.json({
          retcode: code,
          message: msg
        }));
      };
      res.echo = function(str) {
        return buffer += str;
      };
      res.clear = function() {
        return buffer = '';
      };
      res.finish = function(str) {
        if (str == null) {
          str = '';
        }
        return res.end(buffer + str);
      };
      req.qp = function(key, deft) {
        if (deft == null) {
          deft = '';
        }
        if (req.post[key] != null) {
          return req.post[key];
        } else if (query[key] == null) {
          return deft;
        } else {
          return query[key];
        }
      };
      return {
        req: req,
        res: res
      };
    };

    App.prototype.requestListener = function(req, res) {
      var body, query, urlinfo,
        _this = this;

      console.log('====================================================================');
      console.log('request once. ' + new Date().getTime());
      this.attachUtil(req, res);
      urlinfo = url.parse(req.url, true);
      query = urlinfo.query;
      if (urlinfo.pathname !== '/s.q') {
        res.writeHead(404);
        return res.end('404 Page Not Found.');
      } else {
        res.writeHead(200, {
          'Content-Type': 'text/html'
        });
      }
      body = '';
      req.on('data', function(data) {
        return body += data;
      });
      return req.on('end', function() {
        var action;

        req.post = qs.parse(body);
        console.log(req.post);
        action = req.qp('action');
        action || res.dieWithJSON(1, 'require_action');
        if (_this.actions[action] != null) {
          _this.actions[action](req, res);
        } else {
          console.log('no_found_action');
          res.dieWithJSON(1, 'bad_action');
        }
        return res.finish();
      });
    };

    return App;

  })();

  server.startApp((app = new App).requestListener.bind(app));

}).call(this);
