Queues = require './model/Queues'
Queue = require './model/Queue'
Tasks = require './model/Tasks'
Task = require './model/Task'
url = require 'url';
utils = require './utils'
http = require 'http'
querystring = require('querystring');

CONST =
{}
CONST.CON_QUEUE_SPEED = 25
CONST.SEQ_QUEUE_SPEED = 100

class SqiuTaskQueue

	_queues: null
	_tasks: null
	_execCount: 0
	_timer: null
	_fetchCount: 0

	constructor: ->
		@_queues = new Queues model: Queue
		@_tasks = new Tasks model: Task

	start: ->
		_this = @
		console.log 'TaskQueue Start'
		@_timer = setInterval =>
			#console.log 'Task exectute...' + ++@_execCount
			return if @_tasks.length() == 0
			task = @_tasks.shift()
			@_curl(task.get('url'), task.get('postdata'))
			console.log 'Fetched count: ' + ++@_fetchCount
		, CONST.CON_QUEUE_SPEED

		setInterval =>
			#get the queue which type is seq
			@_queues.query {type: Queue.TYPE_SEQ}, false, (results)->

				#define seqWalker
				seqWalker =(queue)->
					tasks = queue.get '_tasks'
					console.log ''
					console.log ''
					console.log 'seqWalker is called once, this mean it\'s a sequence job'
					task = tasks.shift()
					cbk = (->
						return ->
							seqWalker(queue)
					)()

					if task
						_this._curl(task.get('url'), task.get('postdata'), cbk, cbk)
					else
						queue.loading = false

				for queue,i in results
					queue.loading = false if !queue.loading?
					#console.log queue.loading
					_tasks = queue.getTasks()

					queue.loading = false if _tasks.length == 0

					if queue.loading
						console.log _tasks.length
						console.log 'continue'
						continue

					#console.log 'tasks goes here ' + _tasks.length
					if _tasks.length > 0
						queue.loading = true
						seqWalker(queue)
					else
						queue.loading = false

		, CONST.SEQ_QUEUE_SPEED
		true
	stop: ->
		console.log 'TaskQueue Stop'
		clearInterval(@_timer)

	createQueue: (qname, qtype, qlen) ->
		queue = @_queues.getByDataKey('name', qname)
		if queue then return
		@_queues.create
			name: qname
			type: qtype
			len: qlen

	# name
	removeQueue: (qname) ->
		@_queues.removeByName qname

	# name, len, type[seq,conc]
	updateQueue: (qname, new_qinfo) ->
		@_queues.updateByName qname

	# name
	getQueue: (qname) ->
		return @_queues.getByName qname

	# queue_name, url, postdata, prior, options{delay}
	getQueues: (count, top) ->
		@_queues.getAllData()

	# askinfo{url, postdata, prior, options}
	addTask: (qname, taskinfo) ->
		taskinfo.qname = qname
		#console.log taskinfo
		task = new Task taskinfo
		# get queue info
		queue = @_queues.getByDataKey 'name', qname

		return if !queue?

		prior = taskinfo.prior

		if queue.get('type') == Queue.TYPE_SEQ

			if !prior || prior == '0' || prior == 'false'
				queue.getTasks().push task
			else
				queue.getTasks().unshift task
		else
			if !prior || prior == '0' || prior == 'false'
				@_tasks.push task
			else
				@_tasks.unshift task

	getTasks: (qname) ->
		@_tasks.getAllData()

	clearTasks: (qname) ->
		1

	# 并发队列
	addConcTask: ->
		1

	# 顺序队列
	addSeqTask: ->
		1

	# 抓取URL
	_curl: (_url, _postdata, onComplete, onError) ->
		if !_postdata?
			_postdata =
				{}

		#console.log url
		postdata = querystring.stringify _postdata
		if !///^http///.test(_url) then return false

		ufo = url.parse _url, true

		console.log 'Fetching:' + ufo.protocol + '//' + ufo.host + ufo.path + ' ' + utils.datetimeWithMicro()

		post_options =
			host: ufo.hostname
			port: ufo.port
			path: ufo.path
			method: 'POST'
			headers:
				'Content-Type': 'application/x-www-form-urlencoded'
				'Content-Length': postdata.length

		post_req = http.request post_options, (res) ->
			res.setEncoding('utf8');
			res.on 'data', (chunk)->
				#console.log('body: ' + chunk);

			res.on 'end', ->
				console.log('Fetch end at ' + utils.datetimeWithMicro())
				onComplete? && onComplete()

			res.on 'error', (e)->
				console.log 'fetch error'
				onError && onError()

		post_req.on 'error', (e)->
			console.log 'catch fetch error:'
			console.log e

		post_req.write(postdata);
		post_req.end();


module.exports = SqiuTaskQueue