// Generated by CoffeeScript 1.6.2
var CONST, Queue, Queues, SqiuTaskQueue, Task, Tasks, http, querystring, url, utils;

Queues = require('./model/Queues');

Queue = require('./model/Queue');

Tasks = require('./model/Tasks');

Task = require('./model/Task');

url = require('url');

utils = require('./utils');

http = require('http');

querystring = require('querystring');

CONST = {};

CONST.CON_QUEUE_SPEED = 25;

CONST.SEQ_QUEUE_SPEED = 100;

SqiuTaskQueue = (function() {
	SqiuTaskQueue.prototype._queues = null;

	SqiuTaskQueue.prototype._tasks = null;

	SqiuTaskQueue.prototype._execCount = 0;

	SqiuTaskQueue.prototype._timer = null;

	SqiuTaskQueue.prototype._fetchCount = 0;

	function SqiuTaskQueue() {
		this._queues = new Queues({
			model: Queue
		});
		this._tasks = new Tasks({
			model: Task
		});
	}

	SqiuTaskQueue.prototype.start = function() {
		var _this = this;

		_this = this;
		console.log('TaskQueue Start');
		this._timer = setInterval(function() {
			var task;

			if (_this._tasks.length() === 0) {
				return;
			}
			task = _this._tasks.shift();
			_this._curl(task.get('url'), task.get('postdata'));
			return console.log('Fetched count: ' + ++_this._fetchCount);
		}, CONST.CON_QUEUE_SPEED);
		setInterval(function() {
			return _this._queues.query({
				type: Queue.TYPE_SEQ
			}, false, function(results) {
				var i, queue, seqWalker, _i, _len, _results, _tasks;

				seqWalker = function(queue) {
					var cbk, task, tasks;

					tasks = queue.get('_tasks');
					console.log('');
					console.log('');
					console.log('seqWalker is called once, this mean it\'s a sequence job');
					task = tasks.shift();
					cbk = (function() {
						return function() {
							return seqWalker(queue);
						};
					})();
					if (task) {
						return _this._curl(task.get('url'), task.get('postdata'), cbk, cbk);
					} else {
						return queue.loading = false;
					}
				};
				_results = [];
				for (i = _i = 0, _len = results.length; _i < _len; i = ++_i) {
					queue = results[i];
					if (queue.loading == null) {
						queue.loading = false;
					}
					_tasks = queue.getTasks();
					if (_tasks.length === 0) {
						queue.loading = false;
					}
					if (queue.loading) {
						console.log(_tasks.length);
						console.log('continue');
						continue;
					}
					if (_tasks.length > 0) {
						queue.loading = true;
						_results.push(seqWalker(queue));
					} else {
						_results.push(queue.loading = false);
					}
				}
				return _results;
			});
		}, CONST.SEQ_QUEUE_SPEED);
		return true;
	};

	SqiuTaskQueue.prototype.stop = function() {
		console.log('TaskQueue Stop');
		return clearInterval(this._timer);
	};

	SqiuTaskQueue.prototype.createQueue = function(qname, qtype, qlen) {
		var queue;

		queue = this._queues.getByDataKey('name', qname);
		if (queue) {
			return;
		}
		return this._queues.create({
			name: qname,
			type: qtype,
			len: qlen
		});
	};

	SqiuTaskQueue.prototype.removeQueue = function(qname) {
		return this._queues.removeByName(qname);
	};

	SqiuTaskQueue.prototype.updateQueue = function(qname, new_qinfo) {
		return this._queues.updateByName(qname);
	};

	SqiuTaskQueue.prototype.getQueue = function(qname) {
		return this._queues.getByName(qname);
	};

	SqiuTaskQueue.prototype.getQueues = function(count, top) {
		return this._queues.getAllData();
	};

	SqiuTaskQueue.prototype.addTask = function(qname, taskinfo) {
		var prior, queue, task;

		taskinfo.qname = qname;
		task = new Task(taskinfo);
		queue = this._queues.getByDataKey('name', qname);
		if (queue == null) {
			return;
		}
		prior = taskinfo.prior;
		if (queue.get('type') === Queue.TYPE_SEQ) {
			if (!prior || prior === '0' || prior === 'false') {
				return queue.getTasks().push(task);
			} else {
				return queue.getTasks().unshift(task);
			}
		} else {
			if (!prior || prior === '0' || prior === 'false') {
				return this._tasks.push(task);
			} else {
				return this._tasks.unshift(task);
			}
		}
	};

	SqiuTaskQueue.prototype.getTasks = function(qname) {
		return this._tasks.getAllData();
	};

	SqiuTaskQueue.prototype.clearTasks = function(qname) {
		return 1;
	};

	SqiuTaskQueue.prototype.addConcTask = function() {
		return 1;
	};

	SqiuTaskQueue.prototype.addSeqTask = function() {
		return 1;
	};

	SqiuTaskQueue.prototype._curl = function(_url, _postdata, onComplete, onError) {
		var post_options, post_req, postdata, ufo;

		_postdata = _postdata == null ? {} : _postdata;
		postdata = querystring.stringify(_postdata);

		if (!/^http/.test(_url)) {
			return false;
		}
		ufo = url.parse(_url, true);
		console.log('Fetching:' + ufo.protocol + '//' + ufo.host + ufo.path + ' ' + utils.datetimeWithMicro());
		post_options = {
			host: ufo.hostname,
			port: ufo.port,
			path: ufo.path,
			method: 'POST',
			headers: {
				'Content-Type': 'application/x-www-form-urlencoded',
				'Content-Length': postdata.length
			}
		};
		post_req = http.request(post_options, function(res) {
			res.setEncoding('utf8');
			res.on('data', function(chunk) {});
			res.on('end', function() {
				console.log('Fetch end at ' + utils.datetimeWithMicro());
				return (onComplete != null) && onComplete();
			});
			return res.on('error', function(e) {
				console.log('fetch error');
				return onError && onError();
			});
		});
		post_req.on('error', function(e) {
			console.log('catch fetch error:');
			return console.log(e);
		});
		post_req.write(postdata);
		return post_req.end();
	};

	return SqiuTaskQueue;

})();

module.exports = SqiuTaskQueue;
